/* lcs.h
 _______________________________________________________________________
|                                                                       |
|                             Projet LCS                                |
|                         Groupe OLC, CNRS/LAAS                         |
|                        7, Av. du Colonel Roche                        |
|                          31077 Toulouse Cedex                         |
|_______________________________________________________________________|
 
Headers for C-primitives.
 
Version 5.0; May 99;
 
*/
 

#ifndef LCSH
#define LCSH
 


/* endianness: */
#ifndef i486
#define BIG_ENDIAN_TARGET
#endif i486

/* types: */
typedef unsigned char byte;             /* les bytes, de 0 a 255        */
typedef long num;                       /* les entiers 32 bits          */
typedef unsigned long unum;             /* les memes, non signes        */
 
/* lcs args and utilities: */
extern char **ARGV;             /* copy of argv                 */
extern char **ENVP;             /* copy of envp                 */
extern int ARGC;                /* copy of argc                 */
#define bytecore (ARGV[1])      /* core loaded                  */
#define execdir  (ARGV[8])      /* where binaries stand         */
#define appsdir  (ARGV[9])      /* where bytecores stand	*/
#define libsdir  (ARGV[10])     /* lcs libraries directory      */
#define vardir   (ARGV[11])     /* var directory (unused)       */
#define arglist  (ARGV[12])     /* what was passed by -a        */
#define server   (ARGV[13])     /* lcsd server host             */
#define portno   (atoi(ARGV[14])) /* lcsd server port           */
#define protect  (atoi(ARGV[15])) /* protect flag               */
extern long verbose;            /* verbosity flag               */
extern long debug;              /* debug flag                   */
extern num getRunTime();        /* returns process time         */
extern void leave();            /* called on errors             */
extern char *SYSTEMF();         /* lcs-n, lcs-l, or lcs-s       */

/* layout: */
#include "f-cells.h"			/* format layer definitions	*/
extern int page_size;
extern word *topHold;			/* stack boundaries and top	*/
extern word *hold;
extern word *endHold;
extern word freeHeap;           	/* heap boundaries 		*/
extern word endToSpace;           	/* heap boundaries 		*/
extern int mypid;
extern int myaddress;

/* alloc: */
#include "x-alloc.h"			/* allocation macros and funs	*/

/* callbacks: */
extern int register_root(word);         /* user root registration       */
extern word lookup_root(int);           /* user root lookup             */
extern void unregister_root(int);       /* user root clear              */
extern word callml(int, word);          /* calling an ml funct. from C  */

/* collect: */
extern int Collect2();			/* main gc routine		*/
extern void GcStats();			/* prints gc stats on stdout	*/
extern num GcTime;    			/* time spent in gc		*/
extern void GcInfo();                   /* gc stats                     */

/* dump/rest: */
extern num Dump(); 			/* save core image		*/
extern num Restore();			/* load core image		*/

/* equal: */
extern num EqTree();			/* cell equality 		*/
extern num EqConst();			/* constant types equality	*/
extern num EqHunk();			/* hunk equality		*/

/* data types: */
#include "x-arith.h"
#include "x-string.h"
#include "x-exn.h"
/*
#include "d-structs.h"
#include "d-devices.h"
#include "d-mp.h"
*/

#endif LCSH

