(* array.sml
 _______________________________________________________________________
|									|
|			      Projet LCS				|
|			  Groupe OLC, CNRS/LAAS				|
|			 7, Av. du Colonel Roche			|
|			   31077 Toulouse Cedex				|
|_______________________________________________________________________|

arrays

*)




(* interface

type 'a array
exception Subscript : exn
exception Size : exn
val array : int * '1a -> '1a array
val length : 'a array -> int
val sub : 'a array * int -> 'a
val update : 'a array * int * 'a -> unit

val tabulate : int * (int -> 'a) -> 'a array
val arrayoflist : '1a list -> '1a array
val listofarray : '1a array -> '1a list

*)



(* implementation *)

structure Array =
struct

open Core.Array;

local
fun mka [e] n = array (n+1,e)
  | mka (h::t) n = let val a = mka t (n+1) in update (a,n,h); a end;
in
fun arrayoflist [] = [||] | arrayoflist l = mka l 0;
end;

fun tabulate (n,f : int -> 'a) : 'a array =
        if n<=0 then if n<0 then raise Size else [||] else
        let primitive mvect : int -> 'a array = [197]
	    primitive accu : 'a * 'b -> 'b = []
	    val k = ref 0
	in while !k<n
	   do accu (f (!k), inc k);
	   mvect n
	end;

fun listofarray a =
	let fun loa k 0 = [] | loa k n = sub (a,k)::loa (k+1) (n-1)
	in loa 0 (length a)
	end;
end;


