(* bool.sml
 _______________________________________________________________________
|									|
|			      Projet LCS				|
|			  Groupe OLC, CNRS/LAAS				|
|			 7, Av. du Colonel Roche			|
|			   31077 Toulouse Cedex				|
|_______________________________________________________________________|

*)






(* interface

structure Bool =

   datatype bool   [bool]
   con true : bool
   con false : bool

   val = = - : ''a * ''a -> bool
   val <> = - : ''a * ''a -> bool
   val not = - : bool -> bool
   val andalso = - : bool * bool -> bool
   val orelse = - : bool * bool -> bool
   val for_all = - : ('a -> bool) -> 'a list -> bool
   val exists = - : ('a -> bool) -> 'a list -> bool

   exception Bool_of_string : exn
   val bool_of_string = - : string -> bool
   val string_of_bool = - : bool -> string
   val print = - : bool -> bool
   val makestring = - : bool -> string

*)



(* equivalence

datatype bool = true | false
etc,
fun not true = false | not _ = true

non-stricts andalso, orelse are provided as key-words with meaning:
b1 andalso b2 == if b1 then b2 else false
b1 orelse b2 == if b1 then true else b2
*)



(* infix 4 =; *)
infix 4 <>;

structure Bool =
struct
open Core.Bool;
fun x <> y = not(x=y);
fun exists p [] = false | exists p (h::t) = p h orelse exists p t;
fun for_all p [] = true | for_all p (h::t) = p h andalso for_all p t;
fun string_of_bool true = "true" | string_of_bool _ = "false";
exception Bool_of_string;
fun bool_of_string "true" = true
  | bool_of_string "false" = false
  | bool_of_string _ = raise Bool_of_string;
fun print b = (write (string_of_bool b); b);
val makestring = string_of_bool;
end;


(* consider also list iterated connectives in bool.1.sml *)



