(* host.sml
 _______________________________________________________________________
|									|
|			      Projet LCS				|
|			  Groupe OLC, CNRS/LAAS				|
|			 7, Av. du Colonel Roche			|
|			   31077 Toulouse Cedex				|
|_______________________________________________________________________|

*)






(* interface

structure Host =
   exception Host of string
   val date : unit -> (int * int * int * Int * int * int)
   val working_dir : unit -> string
   val change_dir : string -> unit
   val get_env : string -> string
   val set_env : string -> unit
   val system : string -> unit
   val execute : string -> instream * outstream

*)



(* implementation *)

structure Host = Core.Host;




(* notes

date () 	returns (sec,min,hour,day,month,year)
system c	send command c to unix shell
working_dir ()	returns wd as a string
change_dir d 	changes working directory to d
get_env v 	unix environment access
set_env 	unix environment update
execute 	starts a unix process and binds its io descs to ml streams

Some functions may fail with exception Host with a specific string message;
*)
