(* int.sml
 _______________________________________________________________________
|									|
|			      Projet LCS				|
|			  Groupe OLC, CNRS/LAAS				|
|			 7, Av. du Colonel Roche			|
|			   31077 Toulouse Cedex				|
|_______________________________________________________________________|

*)






(* interface

type int
exception Overflow
val ~ : int -> int
val + : int * int -> int
val - : int * int -> int
val * : int * int -> int
exception Div : exn
val div : int * int -> int
val divide : int * int -> int * int
val mod : int * int -> int
val < : int * int -> bool
val > : int * int -> bool
val <= : int * int -> bool
val >= : int * int -> bool
val abs : int -> int
val min : int * int -> int
val max : int * int -> int
exception Pow : exn
val pow : int * int -> int
val rand : int -> int
val seed : unit -> unit
val string_of_int : int -> string
exception Int_of_string : exn
val int_of_string : string -> int
val minint : int
val maxint : int
val print : int -> int
val makestring : int -> string

*)



structure Int =
struct

infix 6 + -;
infix 7 * div pow;
infix 4 < > <= >=;

open Core.Int;
fun abs x = if x<0 then ~x else x;
fun min (x:int,y) = if x<y then x else y
and max (x:int,y) = if x<y then y else x;
exception Pow;
local 
fun rpow x y p =
	if y<0 then raise Pow
        if y<1 then p
	else rpow x (y-1) (p*x:int);
in
fun x pow y = rpow x y 1;
end;
val maxint = (* (2^^30) - 1 *) let val x = 2 pow 29 in x+(x-1) end;
val minint = (* ~(2^^30) *) ~maxint - 1 ;


fun print i = (write (string_of_int i); i);
val makestring = string_of_int;
end;


