(* mp.sml
 _______________________________________________________________________
|									|
|			      Projet LCS				|
|			  Groupe OLC, CNRS/LAAS				|
|			 7, Av. du Colonel Roche			|
|			   31077 Toulouse Cedex				|
|_______________________________________________________________________|

*)






(* interface

(* parsing
mp integers are necessarily prefixed by 0, e.g.
- 0;
val it = 0 : int
- 00;
val it = 00 : mp
*)

type mp
exception Overflow
val ~ : mp -> mp
val + : mp * mp -> mp
val - : mp * mp -> mp
val * : mp * mp -> mp
exception Div : exn
val div : mp * mp -> mp
val divide : mp * mp -> mp * mp
val mod : mp * mp -> mp
val < : mp * mp -> bool
val > : mp * mp -> bool
val <= : mp * mp -> bool
val >= : mp * mp -> bool
val abs : mp -> mp
val min : mp * mp -> mp
val max : mp * mp -> mp
val pow : mp * mp -> mp
val mp : int -> mp
exception Cut : exn
val cut : mp -> int
val string_of_mp : mp -> string
exception Mp_of_string : exn
val mp_of_string : string -> mp
val makestring : mp -> string
val print : mp -> mp
*)



structure Mp =
struct

infix 6 + -;
infix 7 * div pow;
infix 4 < > <= >=;

open Core.Mp;

fun abs (x:mp) = if x < 00 then ~x else x;
fun min (x:mp,y) = if x<y then x else y
and max (x:mp,y) = if x<y then y else x;
local
fun rpow x y p =
	if y<00 then raise Int.Pow
        if y<01 then p
	else rpow x (y-01) (p*x:mp);
in
fun x pow y = rpow x y 01;
end;
fun print m = (write (string_of_mp m); m);
val makestring = string_of_mp;
end;





