(* sort.lcs
 _______________________________________________________________________
|									|
|			      Projet LCS				|
|			  Groupe OLC, CNRS/LAAS				|
|			 7, Av. du Colonel Roche			|
|			   31077 Toulouse Cedex				|
|_______________________________________________________________________|

quick sort, insertion sort.

*)




(* signature:

structure Sort =
   val isort : 'a list -> ('a * 'a -> bool) -> 'a list
   val qsort : 'a list -> ('a * 'a -> bool) -> 'a list

*)


needs "slist";


structure Sort =
struct

(* quick sort *)
fun qsort [] sup = []
  | qsort (h::t) sup = let val (l2,l1) = Slist.partition (fn x => sup (x,h)) t
              	       in (qsort l1 sup) @ [h] @ (qsort l2 sup)
	      	       end;

(* insertion sort *)
fun isort l sup =
let fun insert x [] = [x]
      | insert x (l as (h::t)) = if sup (x,h) then h::insert x t else x::l
    fun sort [] = []
      | sort (h::t) = insert h (sort t)
in sort l
end;

end;

