(* time.sml
 _______________________________________________________________________
|									|
|			      Projet LCS				|
|			  Groupe OLC, CNRS/LAAS				|
|			 7, Av. du Colonel Roche			|
|			   31077 Toulouse Cedex				|
|_______________________________________________________________________|

timing functions.

*)




(* signature

structure Time =
   val check_timer : int * 'a -> int
   val check_timer_gc : 'a * int -> int
   val start_timer : unit -> int * int
   val time : ('a -> 'b) -> 'a -> 'b

*)




(* implementation *)


structure Time =
struct

fun start_timer () = runtime ()
and check_timer (r0,_) = fst (runtime ()) - r0
and check_timer_gc (_,g0) = snd (runtime ()) - g0;

local
fun string_of_time t = (* t.tt s format *)
   let val (s,m) = divide (t,1000)
   in makestring s ^ "." ^ makestring (m div 10) end
in
fun time f x =
		let val (r0,g0) = runtime ()
		    val result = f x
	       val (r1,g1) = runtime ()
		in print (string_of_time (r1-r0)); print " s, "
		 ; 	print (string_of_time (g1-g0)); print " s\n"
		 ; result
		end
end;

end; (* structure *)







